﻿@using System.Web.UI.WebControls;


@using Toyota.Common.Web.Html;
@using Toyota.Common.Web.Html.Helper
@using Toyota.Common.Web.MVC;

@using DevExpress.Web.Mvc;
@using DevExpress.Web.Mvc.UI;
@using DevExpress.Utils;
@using Portal.Models.Delivery.ServiceAcceptance;
@Html.Common().DevExpress().GridView(
        setting =>
        {
            setting.Name = "GridServiceAcceptance";

            setting.CallbackRouteValues = new { Controller = "D31301", Action = "PartialDatas" };
            //setting.ClientSideEvents.CustomButtonClick = "OnEditSupplCodePlantCodeClick";
            setting.ClientSideEvents.BeginCallback = "OnBeginCallbackGrid";
            setting.ClientSideEvents.EndCallback = "OnEndCallbackGrid";
            setting.Width = Unit.Percentage(100);

            setting.Settings.ShowFilterRow = true;
            setting.Settings.ShowFilterRowMenu = true;
            setting.Settings.ShowColumnHeaders = true;

            setting.SettingsBehavior.AllowSelectSingleRowOnly = false;
            setting.SettingsBehavior.AllowSelectByRowClick = false;

            setting.Settings.HorizontalScrollBarMode = ScrollBarMode.Visible;
            setting.Settings.VerticalScrollBarMode = ScrollBarMode.Hidden;
            setting.Styles.Header.HorizontalAlign = HorizontalAlign.Center;
            setting.Styles.Header.VerticalAlign = VerticalAlign.Middle;

            //setting.Settings.UseFixedTableLayout = true;
            setting.SettingsPager.FirstPageButton.Visible = true;
            setting.SettingsPager.LastPageButton.Visible = true;
            setting.SettingsPager.ShowNumericButtons = true;
            setting.SettingsPager.Position = PagerPosition.Bottom;
            setting.SettingsPager.PageSizeItemSettings.Visible = true;
            setting.SettingsPager.PageSizeItemSettings.Items = new string[] { "10", "30", "50", "100" };
            setting.SettingsPager.PageSizeItemSettings.Caption = "Page size";
            setting.HtmlDataCellPrepared = (sender, e) =>
            {
                if (e.DataColumn.FieldName == "DELIVERY_STS")
                {

                    if (e.CellValue.ToString() == "Error Posting")
                    {
                        e.Cell.BackColor = System.Drawing.Color.Red;
                        e.Cell.ForeColor = System.Drawing.Color.White;
                    }
                }


            };


            setting.CustomJSProperties = (sender, e) =>
            {
                MVCxGridView grid = (MVCxGridView)sender;
                int startIndex = 0;

                int endIndex = Model.GetModel<List<ServiceAcceptanceData>>().Count;
                object[] DLV_NO = new object[endIndex - startIndex];
                object[] DLV_STS = new object[endIndex - startIndex];
                object[] INV_NO = new object[endIndex - startIndex];
                object[] isSelected = new object[endIndex - startIndex];

                for (int n = startIndex; n < endIndex; n++)
                {
                    DLV_NO[n - startIndex] = grid.GetRowValues(n, "DELIVERY_NO");
                    DLV_STS[n - startIndex] = grid.GetRowValues(n, "DELIVERY_STS");
                    INV_NO[n - startIndex] = grid.GetRowValues(n, "INV_NO");
                    isSelected[n - startIndex] = grid.Selection.IsRowSelected(n);
                }

                e.Properties["cpDeliveryNo"] = DLV_NO;
                e.Properties["cpDeliverySts"] = DLV_STS;
                e.Properties["cpInvoiceNo"] = INV_NO;
                e.Properties["cpVisibleRowCount"] = grid.VisibleRowCount;
                e.Properties["cpFocusedRowIndex"] = grid.FocusedRowIndex;
                e.Properties["cpKeyfield"] = grid.KeyFieldName;
                e.Properties["cpIsRowSelected"] = isSelected;
                grid.JSProperties["cpPageSize"] = grid.SettingsPager.PageSize;
                grid.JSProperties["cpStartIndex"] = startIndex;
                grid.JSProperties["cpEndIndex"] = endIndex;
                
            };

            setting.CommandColumn.Visible = true;
            setting.CommandColumn.Width = Unit.Pixel(30);
            setting.CommandColumn.ClearFilterButton.Visible = true;
            setting.CommandColumn.ShowSelectCheckbox = true;
            setting.ClientSideEvents.SelectionChanged = "SelectionChange";
            setting.KeyFieldName = "DELIVERY_NO";
            setting.CommandColumn.SetHeaderTemplateContent(
                c =>
                {
                    Html.DevExpress().CheckBox(
                            chckBox =>
                            {
                                //chckBox.Name = "chkAllRecord";
                                chckBox.Name = "CheckAll";
                                chckBox.Properties.ClientSideEvents.CheckedChanged = string.Format("function(s, e) {{ if(s.GetChecked()) {0}.SelectRows(); else {0}.UnselectRows(); }}", setting.Name);
                                chckBox.Checked = c.Grid.Selection.Count > 1;
                                //chckBox.Width = 16;
                                //chckBox.Properties.ClientSideEvents.CheckedChanged = "function(s, e){ GridServiceAcceptance.SelectAllRowsOnPage(chkAllRecord.GetChecked());}";
                                //chckBox.Properties.ClientSideEvents.CheckedChanged = "CheckChange";
                                //chckBox.Checked = c.Grid.Selection.Count > 1;
                            }
                        ).Render();
                }
            );



            setting.Columns.Add(col =>
            {
                col.FieldName = "DELIVERY_NO";
                col.Caption = "Delivery Number";
                col.Width = 110;
                col.CellStyle.HorizontalAlign = System.Web.UI.WebControls.HorizontalAlign.Center;
                col.Settings.AutoFilterCondition = AutoFilterCondition.Contains;
                col.SetDataItemTemplateContent(container =>
                {
                    Html.DevExpress().HyperLink(hlSettings =>
                    {
                        hlSettings.Name = string.Format("hl_{0}", (container as GridViewDataItemTemplateContainer).VisibleIndex);
                        hlSettings.NavigateUrl = "javascript:void(0)";
                        hlSettings.Properties.ClientSideEvents.Click = string.Format("function(s, e) {{ openpop('{0}'); }}", (container as GridViewDataItemTemplateContainer).Text);
                        hlSettings.Properties.Text = (container as GridViewDataItemTemplateContainer).Text;
                    }).Render();
                });
            });


            setting.Columns.Add(
                        column =>
                        {

                            column.Caption = "Delivery Type";
                            column.Name = "DELIVERY_TYPE";
                            column.FieldName = "DELIVERY_TYPE";
                            column.Width = Unit.Pixel(110);
                            column.CellStyle.HorizontalAlign = HorizontalAlign.Center;
                            column.Settings.AutoFilterCondition = AutoFilterCondition.Contains;
                            column.ColumnType = MVCxGridViewColumnType.ComboBox;
                            var combosetting = column.PropertiesEdit as ComboBoxProperties;
                            combosetting.Items.Add("Additional");
                            combosetting.Items.Add("Regular");
                            combosetting.Items.Add("Non TLMS");
                        }
                 );
            setting.Columns.AddBand(
                columnBand =>
                {
                    columnBand.Caption = "Trucking";
                    columnBand.Width = Unit.Percentage(50);
                    columnBand.Columns.Add(
                        column =>
                        {

                            column.Caption = "Code";
                            column.Name = "LP_CD";
                            column.FieldName = "LP_CD";
                            column.Width = Unit.Pixel(50);
                            column.CellStyle.HorizontalAlign = HorizontalAlign.Center;
                            column.Settings.AutoFilterCondition = AutoFilterCondition.Contains;
                        }
                        );

                    columnBand.Columns.Add(
                        column =>
                        {
                            column.Caption = "Name";
                            column.Name = "LP_NAME";
                            column.FieldName = "LP_NAME";
                            column.Width = Unit.Pixel(345);
                            column.CellStyle.HorizontalAlign = HorizontalAlign.Left;
                            column.Settings.AutoFilterCondition = AutoFilterCondition.Contains;
                        }
                        );
                }
                );



            setting.Columns.Add(

                        column =>
                        {
                            column.Caption = "Route - Rate";
                            column.Name = "ROUTE_RATE";
                            column.FieldName = "ROUTE_RATE";
                            column.Width = Unit.Pixel(100);
                            column.CellStyle.HorizontalAlign = HorizontalAlign.Center;
                            column.Settings.AutoFilterCondition = AutoFilterCondition.Contains;

                        }
            );

            setting.Columns.Add(

                        column =>
                        {
                            column.Caption = "Pickup date";
                            column.Name = "PICKUP_DT";
                            column.FieldName = "PICKUP_DT";
                            column.ColumnType = MVCxGridViewColumnType.DateEdit;
                            column.PropertiesEdit.DisplayFormatString = "dd.MM.yyyy";
                            var dateEditProperties = column.PropertiesEdit as DateEditProperties;
                            dateEditProperties.EditFormat = EditFormat.DateTime;
                            dateEditProperties.EditFormatString = "dd.MM.yyyy";
                            dateEditProperties.UseMaskBehavior = true;

                            column.Width = Unit.Pixel(140);
                            column.CellStyle.HorizontalAlign = HorizontalAlign.Center;
                            column.Settings.AutoFilterCondition = AutoFilterCondition.Contains;

                        }
            );

            setting.Columns.Add(
                        column =>
                        {
                            column.Caption = "Status";
                            column.Name = "DELIVERY_STS";
                            column.FieldName = "DELIVERY_STS";
                            column.Width = Unit.Pixel(90);
                            column.CellStyle.HorizontalAlign = HorizontalAlign.Center;
                            column.Settings.AutoFilterCondition = AutoFilterCondition.Contains;
                            column.ColumnType = MVCxGridViewColumnType.ComboBox;
                            var combosetting = column.PropertiesEdit as ComboBoxProperties;
                            combosetting.Items.Add("Initial");
                            combosetting.Items.Add("Downloaded");
                            combosetting.Items.Add("Arrived");
                            combosetting.Items.Add("Delivered");
                            combosetting.Items.Add("Approved");
                            combosetting.Items.Add("Posted");
                            combosetting.Items.Add("Error Posting");
                            combosetting.Items.Add("Canceled");


                            column.SetDataItemTemplateContent(container =>
                            {
                                if ((container as GridViewDataItemTemplateContainer).Text == "Error Posting")
                                {
                                    Html.DevExpress().HyperLink(hlSettings =>
                                    {
                                        hlSettings.Name = string.Format("hs_{0}", (container as GridViewDataItemTemplateContainer).VisibleIndex);
                                        hlSettings.NavigateUrl = "javascript:void(0)";
                                        hlSettings.Properties.ClientSideEvents.Click = string.Format("function(s, e) {{ detailError('{0}'); }}", (container as GridViewDataItemTemplateContainer).KeyValue);
                                        hlSettings.Properties.Text = (container as GridViewDataItemTemplateContainer).Text;
                                    }).Render();
                                }
                                else
                                {
                                    Html.DevExpress().Label(lbSetting =>
                                    {
                                        lbSetting.Text = (container as GridViewDataItemTemplateContainer).Text;
                                    }).Render();
                                }

                            });
                        }
            );

            setting.Columns.Add(
                        column =>
                        {
                            column.Caption = "SA Notes";
                            column.FieldName = "SA_NOTES";
                            column.Width = Unit.Pixel(150);
                            column.CellStyle.HorizontalAlign = HorizontalAlign.Center;
                            column.Settings.AutoFilterCondition = AutoFilterCondition.Contains;
                            column.SetDataItemTemplateContent(c =>
                            {
                                var x = (c as GridViewDataItemTemplateContainer).Text;
                                var a = (c as GridViewDataItemTemplateContainer).VisibleIndex;

                                string[] y = x.Split('|');
                                if (y[0] == "yes" && y[1] == "")
                                {
                                    Html.DevExpress().TextBox(
                                    tboxSettings =>
                                    {
                                        tboxSettings.Name = string.Format("txtSA_Notes[{0}]", (c as GridViewDataItemTemplateContainer).VisibleIndex);
                                        tboxSettings.Width = Unit.Pixel(100);
                                        tboxSettings.Enabled = true;
                                        tboxSettings.Properties.Style.ForeColor = System.Drawing.Color.Black;
                                        tboxSettings.Style.Add("display", "inline-table");

                                    }
                                ).Render();

                                    Html.DevExpress().Button(
                                        button =>
                                        {
                                            button.Name = string.Format("btnOK[{0}]", (c as GridViewDataItemTemplateContainer).VisibleIndex);
                                            button.Text = "OK";
                                            button.Width = Unit.Pixel(15);
                                            button.Height = Unit.Pixel(10);
                                            button.UseSubmitBehavior = true;
                                            button.Style.Add("display", "inline-table");
                                            button.ControlStyle.CssClass = "btnOkeh";

                                            //button.ClientSideEvents.Click = "saveNotes("+a.ToString()+")";
                                            button.ClientSideEvents.Click = string.Format("function(s,e){{ saveNotes({0}); }}", (c as GridViewDataItemTemplateContainer).VisibleIndex);

                                        }).Render();

                                }
                                else
                                {
                                    Html.DevExpress().Label(lbSetting =>
                                    {
                                        lbSetting.Text = y[1];
                                    }).Render();
                                }

                            });
                        }
            );

            setting.Columns.AddBand(
                columnBand =>
                {
                    columnBand.Caption = "Achievement";
                    columnBand.Columns.Add(
                        column =>
                        {
                            //edtSettings.Properties.DisplayFormatString = "dd.MM.yyyy";
                            //edtSettings.Properties.EditFormatString = "dd.MM.yyyy";
                            column.Caption = "Arrival";
                            column.Name = "ARRIVAL";
                            column.FieldName = "ARRIVAL";
                            column.ColumnType = MVCxGridViewColumnType.DateEdit;
                            column.PropertiesEdit.DisplayFormatString = "dd.MM.yyyy HH:mm";
                            var dateEditProperties = column.PropertiesEdit as DateEditProperties;
                            dateEditProperties.EditFormat = EditFormat.DateTime;
                            dateEditProperties.EditFormatString = "dd.MM.yyyy";
                            dateEditProperties.UseMaskBehavior = true;

                            column.Width = Unit.Pixel(140);
                            column.CellStyle.HorizontalAlign = HorizontalAlign.Center;
                            column.Settings.AutoFilterCondition = AutoFilterCondition.Contains;
                        }
                        );

                    columnBand.Columns.Add(
                        column =>
                        {
                            column.Caption = "Departure";
                            column.Name = "DEPARTURE";
                            column.FieldName = "DEPARTURE";
                            column.ColumnType = MVCxGridViewColumnType.DateEdit;
                            column.PropertiesEdit.DisplayFormatString = "dd.MM.yyyy HH:mm";
                            var dateEditProperties = column.PropertiesEdit as DateEditProperties;
                            dateEditProperties.EditFormat = EditFormat.DateTime;
                            dateEditProperties.EditFormatString = "dd.MM.yyyy";
                            dateEditProperties.UseMaskBehavior = true;
                            column.Width = Unit.Pixel(140);
                            column.CellStyle.HorizontalAlign = HorizontalAlign.Center;
                            column.Settings.AutoFilterCondition = AutoFilterCondition.Contains;
                        }
                        );
                }
                );



            setting.Columns.Add(
                        column =>
                        {
                            column.Caption = "PO Number";
                            column.Name = "PO_NO";
                            column.FieldName = "PO_NO";
                            column.Width = Unit.Pixel(90);
                            column.CellStyle.HorizontalAlign = HorizontalAlign.Center;
                            column.Settings.AutoFilterCondition = AutoFilterCondition.Contains;

                        }
            );

            //detail


            setting.Columns.AddBand(
                  columnBand =>
                  {
                      columnBand.Caption = "Financial Document";
                      columnBand.Name = "FINANCIAL_DOCUMENT";
                      columnBand.Visible = false;
                      columnBand.Columns.Add(
                          column =>
                          {
                              column.Caption = "Mat Doc No";
                              column.Name = "MATDOC_NO";
                              column.FieldName = "MATDOC_NO";
                              column.Width = Unit.Pixel(90);
                              column.CellStyle.HorizontalAlign = HorizontalAlign.Center;
                              column.Settings.AutoFilterCondition = AutoFilterCondition.Contains;

                          }
                       );

                      columnBand.Columns.Add(
                          column =>
                          {
                              column.Caption = "Acct Doc No";
                              column.Name = "ACCT_DOC_NO";
                              column.FieldName = "ACCT_DOC_NO";
                              column.Width = Unit.Pixel(90);
                              column.CellStyle.HorizontalAlign = HorizontalAlign.Center;
                              column.Settings.AutoFilterCondition = AutoFilterCondition.Contains;

                          }
                       );

                      columnBand.Columns.Add(
                          column =>
                          {
                              column.Caption = "Acct Doc No";
                              column.Name = "ACCT_DOC_YEAR";
                              column.FieldName = "ACCT_DOC_YEAR";
                              column.Width = Unit.Pixel(90);
                              column.CellStyle.HorizontalAlign = HorizontalAlign.Center;
                              column.Settings.AutoFilterCondition = AutoFilterCondition.Contains;

                          }
                       );

                      columnBand.Columns.Add(
                          column =>
                          {
                              column.Caption = "Clearing Doc No";
                              column.Name = "CLEAR_DOC_NO";
                              column.FieldName = "CLEAR_DOC_NO";
                              column.Width = Unit.Pixel(90);
                              column.CellStyle.HorizontalAlign = HorizontalAlign.Center;
                              column.Settings.AutoFilterCondition = AutoFilterCondition.Contains;

                          }
                       );
                      
                      columnBand.Columns.Add(
                          column =>
                          {
                              column.Caption = "Document Date";
                              column.Name = "POSTING_DT";
                              column.FieldName = "POSTING_DT";
                              column.ColumnType = MVCxGridViewColumnType.DateEdit;
                              column.PropertiesEdit.DisplayFormatString = "dd.MM.yyyy";
                              var dateEditProperties = column.PropertiesEdit as DateEditProperties;
                              dateEditProperties.EditFormat = EditFormat.DateTime;
                              dateEditProperties.EditFormatString = "dd.MM.yyyy";
                              dateEditProperties.UseMaskBehavior = true;
                              column.Width = Unit.Pixel(140);
                              column.CellStyle.HorizontalAlign = HorizontalAlign.Center;
                              column.Settings.AutoFilterCondition = AutoFilterCondition.Contains;

                          }
                      );

                      columnBand.Columns.Add(
                        column =>
                        {
                            column.Caption = "PIC";
                            column.Name = "PIC";
                            column.FieldName = "PIC";
                            column.Width = Unit.Pixel(80);
                            column.CellStyle.HorizontalAlign = HorizontalAlign.Center;
                            column.Settings.AutoFilterCondition = AutoFilterCondition.Contains;

                        }
                    );
                  }
             );


            setting.Columns.AddBand(
                columnBand =>
                {
                    columnBand.Caption = "Supplier Invoice";
                    columnBand.Name = "SUPPLIER_INVOICE";
                    columnBand.Visible = false;
                    columnBand.Columns.Add(
                        column =>
                        {
                            column.Caption = "Invoice No";
                            column.Name = "INV_NO";
                            column.FieldName = "INV_NO";
                            column.Width = Unit.Pixel(90);
                            column.CellStyle.HorizontalAlign = HorizontalAlign.Center;
                            column.Settings.AutoFilterCondition = AutoFilterCondition.Contains;

                        }
                     );

                    columnBand.Columns.Add(
                        column =>
                        {
                            column.Caption = "Invoice Date";
                            column.Name = "INV_DT";
                            column.FieldName = "INV_DT";
                            column.ColumnType = MVCxGridViewColumnType.DateEdit;
                            column.PropertiesEdit.DisplayFormatString = "dd.MM.yyyy HH:mm";
                            var dateEditProperties = column.PropertiesEdit as DateEditProperties;
                            dateEditProperties.EditFormat = EditFormat.DateTime;
                            dateEditProperties.EditFormatString = "dd.MM.yyyy";
                            dateEditProperties.UseMaskBehavior = true;
                            column.Width = Unit.Pixel(140);
                            column.CellStyle.HorizontalAlign = HorizontalAlign.Center;
                            column.Settings.AutoFilterCondition = AutoFilterCondition.Contains;

                        }
                    );

                    columnBand.Columns.Add(
                        column =>
                        {
                            column.Caption = "PIC";
                            column.Name = "INV_POSTING_BY";
                            column.FieldName = "INV_POSTING_BY";
                            column.Width = Unit.Pixel(80);
                            column.CellStyle.HorizontalAlign = HorizontalAlign.Center;
                            column.Settings.AutoFilterCondition = AutoFilterCondition.Contains;

                        }
                    );

                }
           );


            setting.Columns.AddBand(
                 columnBand =>
                 {
                     columnBand.Caption = "Cancellation";
                     columnBand.Name = "CANCELLATION";
                     columnBand.Visible = false;
                     columnBand.Columns.Add(
                         column =>
                         {
                             column.Caption = "MatDoc No";
                             column.Name = "MATDOC_NO2";
                             column.FieldName = "MATDOC_NO2";
                             column.Width = Unit.Pixel(90);
                             column.CellStyle.HorizontalAlign = HorizontalAlign.Center;
                             column.Settings.AutoFilterCondition = AutoFilterCondition.Contains;
                         }
                      );

                     columnBand.Columns.Add(
                         column =>
                         {
                             column.Caption = "Cancel Date";
                             column.Name = "CANCEL_DT";
                             column.FieldName = "CANCEL_DT";
                             column.ColumnType = MVCxGridViewColumnType.DateEdit;
                             column.PropertiesEdit.DisplayFormatString = "dd.MM.yyyy HH:mm";
                             var dateEditProperties = column.PropertiesEdit as DateEditProperties;
                             dateEditProperties.EditFormat = EditFormat.DateTime;
                             dateEditProperties.EditFormatString = "dd.MM.yyyy";
                             dateEditProperties.UseMaskBehavior = true;
                             column.Width = Unit.Pixel(140);
                             column.CellStyle.HorizontalAlign = HorizontalAlign.Center;
                             column.Settings.AutoFilterCondition = AutoFilterCondition.Contains;

                         }
                     );

                     columnBand.Columns.Add(
                         column =>
                         {
                             column.Caption = "PIC";
                             column.Name = "PIC2";
                             column.FieldName = "PIC2";
                             column.Width = Unit.Pixel(80);
                             column.CellStyle.HorizontalAlign = HorizontalAlign.Center;
                             column.Settings.AutoFilterCondition = AutoFilterCondition.Contains;
                         }
                     );

                 }
            );

        }).Bind(Model.GetModel<List<ServiceAcceptanceData>>()).GetHtml()




